> ## Documentation Index
> Fetch the complete documentation index at: https://conductorone-docs-api-common-tasks-cookbook.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# List Attribute Types

> List the well-known and custom user attribute types available for configuring mappings.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples get /api/v1/user-attribute-types
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/user-attribute-types:
    get:
      tags:
        - UserAttributeMappings
      summary: List Attribute Types
      description: >-
        List the well-known and custom user attribute types available for
        configuring mappings.
      operationId: c1.api.user.v1.UserAttributeManagementService.ListAttributeTypes
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/c1.api.user.v1.UserAttributeManagementServiceListAttributeTypesResponse
          description: Successful response
components:
  schemas:
    c1.api.user.v1.UserAttributeManagementServiceListAttributeTypesResponse:
      description: The UserAttributeManagementServiceListAttributeTypesResponse message.
      properties:
        list:
          description: The list field.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeType'
          type:
            - array
            - 'null'
      title: User Attribute Management Service List Attribute Types Response
      type: object
      x-speakeasy-name-override: UserAttributeManagementServiceListAttributeTypesResponse
    c1.api.user.v1.UserAttributeType:
      description: >
        The UserAttributeType message.


        This message contains a oneof named config. Only a single field of the
        following list may be set at a time:
          - app
          - appUserProfile
          - customAppUserProfile
          - celExpression
      properties:
        app:
          oneOf:
            - $ref: '#/components/schemas/c1.api.user.v1.UserAttributeTypeConfigApp'
            - type: 'null'
        appUserProfile:
          oneOf:
            - $ref: >-
                #/components/schemas/c1.api.user.v1.UserAttributeTypeConfigAppUserProfile
            - type: 'null'
        celExpression:
          oneOf:
            - $ref: >-
                #/components/schemas/c1.api.user.v1.UserAttributeTypeConfigCelExpression
            - type: 'null'
        customAppUserProfile:
          oneOf:
            - $ref: >-
                #/components/schemas/c1.api.user.v1.UserAttributeTypeConfigCustomAppUserProfile
            - type: 'null'
        displayName:
          description: The displayName field.
          type: string
        id:
          description: The id field.
          type: string
      required:
        - id
      title: User Attribute Type
      type: object
      x-speakeasy-name-override: UserAttributeType
    c1.api.user.v1.UserAttributeTypeConfigApp:
      description: The UserAttributeTypeConfigApp message.
      properties:
        appId:
          description: The appId field.
          type: string
      title: User Attribute Type Config App
      type: object
      x-speakeasy-name-override: UserAttributeTypeConfigApp
    c1.api.user.v1.UserAttributeTypeConfigAppUserProfile:
      description: The UserAttributeTypeConfigAppUserProfile message.
      properties:
        appId:
          description: The appId field.
          type: string
        appUserProfileAttributeKey:
          description: The appUserProfileAttributeKey field.
          type: string
      title: User Attribute Type Config App User Profile
      type: object
      x-speakeasy-name-override: UserAttributeTypeConfigAppUserProfile
    c1.api.user.v1.UserAttributeTypeConfigCelExpression:
      description: The UserAttributeTypeConfigCelExpression message.
      properties:
        celExpression:
          description: The celExpression field.
          type: string
        userProfileAttributeKey:
          description: The userProfileAttributeKey field.
          type: string
      title: User Attribute Type Config Cel Expression
      type: object
      x-speakeasy-name-override: UserAttributeTypeConfigCelExpression
    c1.api.user.v1.UserAttributeTypeConfigCustomAppUserProfile:
      description: The UserAttributeTypeConfigCustomAppUserProfile message.
      properties:
        appId:
          description: The appId field.
          type: string
        appUserProfileAttributeKey:
          description: The appUserProfileAttributeKey field.
          type: string
        userProfileAttributeKey:
          description: The userProfileAttributeKey field.
          type: string
      title: User Attribute Type Config Custom App User Profile
      type: object
      x-speakeasy-name-override: UserAttributeTypeConfigCustomAppUserProfile
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````